%define oname   activerecord

%define subrel  1

Name:       ruby-%{oname}
Version:    2.3.11
Release:    %mkrel 1
Summary:    Implements the ActiveRecord pattern for ORM
Group:      Development/Ruby
License:    MIT
URL:        http://www.rubyonrails.org
Source0:    http://rubygems.org/downloads/%{oname}-%{version}.gem
# taken from upstream http://groups.google.com/group/rubyonrails-security/browse_thread/thread/6a1e473744bc389b
Patch0:     2-3-stable-fix-sql-injection-CVE-2011-2930.patch
BuildRequires: rubygems
BuildRequires: rubygem(rake)
BuildRequires: rubygem(activesupport) = %{version}
BuildRequires: rubygem(mocha)
BuildRequires: rubygem(pg)
BuildRequires: rubygem(mysql)
BuildRequires: rubygem(sqlite3)
BuildRequires: mysql
BuildRequires: postgresql-server
BuildRequires: locales
BuildArch:  noarch

%description
Implements the ActiveRecord pattern (Fowler, PoEAA) for ORM. It ties
database tables and classes together for business objects, like Customer or
Subscription, that can find, save, and destroy themselves without resorting
to manual SQL.

%files
%defattr(-, root, root, -)
%dir %{ruby_gemdir}/gems/%{oname}-%{version}/
%{ruby_gemdir}/gems/%{oname}-%{version}/lib
%{ruby_gemdir}/specifications/%{oname}-%{version}.gemspec

#-------------------------------------------------------------------------------
%package        doc
Summary:    Documentation for %{name}
Group:      Development/Ruby
Requires:   %{name} = %{version}-%{release}

%description    doc
Documents, Rdoc & RI documentation for %{name}.
%files          doc
%defattr(-,root,root,-)
%doc %{ruby_gemdir}/doc/%{oname}-%{version}
%doc %{ruby_gemdir}/gems/%{oname}-%{version}/README
#-------------------------------------------------------------------------------

%prep
%setup -q
tar xmf data.tar.gz
%patch0 -p2 -b .2-3-stable-fix-sql-injection-CVE-2011-2930


%build
%gem_build

%install
rm -rf %{buildroot}
%gem_install

%check
rake test_sqlite3

# start an unprivileged instance of mysql
mysql_install_db --datadir=$PWD/var/lib/mysql/ --user=$USER
/usr/sbin/mysqld --datadir=$PWD/var/lib/mysql \
  --socket $PWD/var/lib/mysql.sock \
  --pid-file $PWD/var/lib/mysqld.pid &
export MYSQL_SOCK=$PWD/var/lib/mysql.sock
# FIXME: add a delay so that mysql is fully started when running other commands
sleep 10
# create the test databases
echo "create database activerecord_unittest character set utf8;" | mysql --socket $PWD/var/lib/mysql.sock
echo "create database activerecord_unittest2;" | mysql --socket $PWD/var/lib/mysql.sock
# create the rails user
echo "create user 'rails'@'localhost';
grant all privileges on activerecord_unittest.*  to 'rails'@'localhost';
grant all privileges on activerecord_unittest2.* to 'rails'@'localhost';" | mysql --socket $PWD/var/lib/mysql.sock
# fix socket for the test
sed -i '/:username.*/a \
    :socket => "var/lib/mysql.sock",' test/connections/native_mysql/connection.rb
rake test_mysql
kill `cat $PWD/var/lib/mysqld.pid`

# start postgresql
mkdir -p $PWD/var/log/postgres/
initdb -D $PWD/var/lib/pgsql/data --locale=UTF-8
pg_ctl start -l $PWD/var/log/postgres/postgresql \
    -D $PWD/var/lib/pgsql/data
# FIXME: add a delay so that pgsql is fully started when running other commands
sleep 10
#create the test database
createdb -E UTF-8 activerecord_unittest
createdb -E UTF-8 activerecord_unittest2
rake test_postgresql
pg_ctl stop -D $PWD/var/lib/pgsql/data -m "fast"

%clean
rm -rf %{buildroot}



%changelog

* Mon Sep 12 2011 doktor5000 <doktor5000> 2.3.11-1.1.mga1
+ Revision: 142685
- add locales as BuildRequire for UTF-8 locale
- fix CVE-2011-2930 (2-3-stable-fix-sql-injection-CVE-2011-2930.patch)

* Fri Feb 11 2011 shikamaru <shikamaru> 2.3.11-1.mga1
+ Revision: 50619
- new version 2.3.11

* Mon Jan 31 2011 shikamaru <shikamaru> 2.3.10-4.mga1
+ Revision: 45439
- add postgresql check
- add check for mysql

* Sat Jan 29 2011 shikamaru <shikamaru> 2.3.10-3.mga1
+ Revision: 43871
- Add check section
- test sqlite3
- TODO: test mysql
- TODO: test postgresql
- imported package ruby-activerecord


* Sun Jan 23 2011 Remy CLOUARD <shikamaru@myoboku.shikamaru.fr> - 2.3.10-3mdv2011.0
- Apply new ruby policy
- Apply general mageia policy

* Thu Dec 09 2010 Rémy Clouard <shikamaru@mandriva.org> 2.3.10-2mdv2011.0
+ Revision: 618291
- add provides to fix rails dependencies

* Fri Oct 15 2010 Rémy Clouard <shikamaru@mandriva.org> 2.3.10-1mdv2011.0
+ Revision: 585834
- bump release

* Sat Sep 18 2010 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.3.9-1mdv2011.0
+ Revision: 579507
- new release: 2.3.9

* Sun Sep 13 2009 Frederik Himpe <fhimpe@mandriva.org> 2.3.4-1mdv2010.0
+ Revision: 438623
- Update to new version 2.3.4

* Thu Jul 30 2009 Frederik Himpe <fhimpe@mandriva.org> 2.3.3-1mdv2010.0
+ Revision: 404837
- Update to new version 2.3.3
- Suggest ruby-mysql and ruby-sqlite3
- Remove socket location patch: socket location does not seem to be defined
  in activerecord anymore

* Fri Jun 12 2009 Lev Givon <lev@mandriva.org> 2.1.2-1mdv2010.0
+ Revision: 385323
- Update to 2.1.2.

* Fri Aug 08 2008 Thierry Vignaud <tv@mandriva.org> 2.1.0-1mdv2009.0
+ Revision: 269228
- rebuild early 2009.0 package (before pixel changes)

* Tue Jun 03 2008 Alexander Kurtakov <akurtakov@mandriva.org> 2.1.0-0mdv2009.0
+ Revision: 214638
- new version 2.1.0

* Mon Jan 14 2008 Alexander Kurtakov <akurtakov@mandriva.org> 2.0.2-1mdv2008.1
+ Revision: 151291
- new version

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Mon Apr 23 2007 Olivier Blin <oblin@mandriva.com> 1.15.3-1mdv2008.0
+ Revision: 17559
- 1.15.3

* Sat Apr 21 2007 Pascal Terjan <pterjan@mandriva.org> 1.14.4-2mdv2008.0
+ Revision: 16687
- ri is now in ri/ and not ri/ri/
- Use Development/Ruby group


* Thu Nov 16 2006 Olivier Blin <oblin@mandriva.com> 1.14.4-1mdv2007.0
+ Revision: 84915
- 1.14.4
- Import ruby-activerecord

* Sat Jul 29 2006 Olivier Blin <blino@mandriva.com> 1.14.3-2mdv2007.0
- Patch0: default to /var/lib/mysql/mysql.sock

* Sat Jul 29 2006 Olivier Blin <blino@mandriva.com> 1.14.3-1mdv2007.0
- 1.14.3

* Fri Feb 17 2006 Pascal Terjan <pterjan@mandriva.org> 1.13.2-2mdk
- Use system macro
- Ship the gemspec

* Mon Feb 06 2006 Pascal Terjan <pterjan@mandriva.org> 1.13.2-1mdk
- 1.13.2
- use gem
- mkrel

* Wed Jul 20 2005 Pascal Terjan <pterjan@mandriva.org> 1.11.1-1mdk 
- First Mandriva release

